// cfunction.cpp
// Integration of a C-function
// M. Bernreuther, 6.2.2001



#include "Numegration.h"

#include <iostream>
using namespace std;

#include <math.h>

const double PI=3.1415926535897932384626433832795;


double f1(double x)
{
	return sin(x);
}

double f2(double x,double y)
{
	return sin(x)*cos(y);
}



int main(int argc, char *argv[ ])
{
	unsigned int i;

	cout << "1D Integration of sin(x) [0,PI] = 2" << endl;
	Numegration::Points1D ip1(2,Numegration::GaussChebyshev,0.,PI);
	cout << "Gauss Chebyshev" << endl;
	for(i=2;i<=10;i++)
	{
		ip1.Setn(i);
		cout << i << ": " << endl;		
		cout << ip1.Integrate(&f1) << endl;
	}

	cout << "2D Integration of sin(x)*cos(y) [0,PI][0,2*PI] = 0" << endl;
	Numegration::Points2D ip2(2,Numegration::GaussLobatto
	                         ,2,Numegration::GaussLobatto
				 ,0.,PI,0.,2*PI);
	cout << "Gauss Lobatto (i,i)" << endl;
	for(i=1;i<=10;i++)
	{
		ip2.Setn(i,i);
		cout << i << ": " << endl;
		cout << ip2.Integrate(&f2) << endl;
	}
	
	return 0;
}
