// functionclass.cpp
// Integration of a function encapsulated in a class
// M. Bernreuther, 6.2.2001



#include "Numegration.h"

#include <iostream>
using namespace std;

#include <math.h>

class Cf1 : public Numegration::Function1D
{
public:
	double operator()(double x){return exp(x);};
};

class Cf2 : public Numegration::Function2D
{
public:
	double operator()(double x1, double x2){return x1*sqrt(x2);};
};




int main(int argc, char *argv[ ])
{
	unsigned int i;

	cout << "1D Integration of exp(x) [0,2] = e^2-1 = 6,389056098930650227230427460575" << endl;
	Numegration::Points1D ip1(2,Numegration::Trapezoid);
	ip1.SetBounds(0.,2.);
	cout << "Trapezoidal" << endl;
	Cf1 cf1;
	for(i=2;i<=20;i++)
	{
		ip1.Setn(i);
		cout << i << ": " << endl;
		cout << ip1.Integrate(cf1) << endl;
	}

	cout << "2D Integration of x1*sqrt(x2) [0,1.][1.,4.] = 7/3 = 2.333..." << endl;
	Numegration::Points2D ip2(1,Numegration::GaussLegendre);
	ip2.SetBounds(0.,1.,1.,4.);
	cout << "Gauss Legendre" << endl;
	Cf2 cf2;
	for(i=1;i<=24;i++)
	{
		ip2.Setn(i,i);
		cout << i << ": " << endl;
		cout << ip2.Integrate(cf2) << endl;
	}
	
	return 0;
}
