// main.cpp
// Integration
// M. Bernreuther, 15.9.2000



#include "Numegration.h"

#include <iostream>
using namespace std;

#include <math.h>

const double PI=3.1415926535897932384626433832795;


double f1(double x)
{
	return sin(x);
}

double f2(double x,double y)
{
	return sin(x)*cos(y);
}


class Cf1 : public Numegration::Function1D
{
public:
	double operator()(double x){return exp(x);};
};

class Cf2 : public Numegration::Function2D
{
public:
	double operator()(double x1, double x2){return x1*x1*x2*x2;};
};




int main(int argc, char *argv[ ])
{
	unsigned int i,j;

	cout << "1D Integration" << endl;
	Numegration::Points1D ip1(2,Numegration::GaussChebyshev,0.,PI);
	cout << "Gauss Chebyshev" << endl;
	valarray<double> abscissas,weights;
	Cf1 cf1;
	for(i=2;i<=10;i++)
	{
		ip1.Setn(i);
		cout << i << ": " << endl;
		
		abscissas=ip1.GetAbscissas();
		for(j=0;j<abscissas.size();j++)
			cout << abscissas[j] << "\t";
		cout << endl;
		weights=ip1.GetWeights();
		for(j=0;j<weights.size();j++)
			cout << weights[j] << "\t";
		cout << endl;
		
		cout << ip1.Integrate(&f1)
			 << "\t" << ip1.Integrate(cf1) << endl;
	}

	return 0;

	unsigned int k;
	valarray<double> abscissas1,abscissas2;
	vector<valarray<double> > weights2;

	cout << "2D Integration" << endl;
	Numegration::Points2D ip2(1,Numegration::GaussLegendre);
	cout << "Gauss Legendre" << endl;
	Cf2 cf2;
	for(i=1;i<=24;i++)
	{
		ip2.Setn(i,i);
		cout << i << ": " << endl;
		
		abscissas1=ip2.GetAbscissas1();
		abscissas2=ip2.GetAbscissas2();
		for(j=0;j<abscissas1.size();j++)
		{
			for(k=0;k<abscissas2.size();k++)
				cout << abscissas1[k] << ";" << abscissas2[j] << "\t";
			cout << endl;
		}
		cout << endl;
		weights2=ip2.GetWeights();
		for(j=0;j<weights2.size();j++)
		{
			for(k=0;k<weights2[j].size();k++)
				cout << weights2[j][k] << "\t";
			cout << endl;
		}
		cout << endl;
		
		cout << ip2.Integrate(&f2)
			 << "\t" << ip2.Integrate(cf2) << endl;
	}
	
	return 0;
}
